// partition:  a container for organizing a set of sequential integers
//             into non-overlapping groups.
// Version:    0.1
// Copyright 2013 Matthew T. Busche.
//
// This program is free software:  you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation, either version 3 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.

package org.mattbusche.util.partition;

class Node<M,V>
{
    Group<M,V> _group;
    Node<M,V>  _prev;
    Node<M,V>  _next;
    Entry<M>   _entry;

    Node(int id)
    {
        _entry = new Entry<M>(id);
    }


    Node(int id, M member)
    {
        _entry = new Entry<M>(id, member);
    }


    /** This constructor used to create the _end Node for Groups.  Since the
     ** end node has no entry it is appropriately left null.
     **/
    Node(Group<M,V> group)
    {
        _group = group;
        _prev = this;
        _next = this;
    }
}
